#include<stdio.h>
#include<ctype.h>
#include<math.h>
#include<stdlib.h>
#include<string.h>

/* ***************************************************************************** */

main(argc,argv)
int argc ;
char *argv[] ;
{

      FILE *out, *out2;
      FILE *mhfil;

      int i, j, k, m, n, jemx, par_num, ncases;
      char oname[100], dummy[100], sweethome[200];
      char mhline[410], alfil[200], dum;
      double indat[220][3]; 
      float par_low, par_high, par_step, par_val;
   
   
      sprintf(sweethome, "/home/nl/jemx/ipfread/jemx1-2");
      printf("%s\n", sweethome);
        
      for (i=0; i<220; i++) indat[i][0] = indat[i][1] = indat[i][2] = 999.999;
      
      if (argc > 5) jemx = atoi(argv[1]) ;           
      else {printf("jemx par_num par_low, par_high, par_step\n"); return;}
      par_num = atoi(argv[2]);
      par_low = atof(argv[3]);
      par_high = atof(argv[4]);
      par_step = atof(argv[5]);
      ncases = (par_high - par_low) / par_step;
      if (ncases < 1) {
	  printf("Bad input!!\n");
          scanf("%1c", dum);
          if (dum != 'y') goto wait;
      }
      if (ncases > 10) {
	  printf("Number of cases: %d\n", ncases);
wait:     scanf("%1c", dum);
          if (dum != 'y') goto wait;
	  exit(0);
      }

      sprintf(alfil, "../alignment.dat");
      mhfil = fopen(alfil, "rt");
      if (mhfil != NULL) goto al_sta;

      sprintf(alfil, "%s/reference/alignment.dat", sweethome);
      mhfil = fopen(alfil, "rt");
      if (mhfil == NULL) {
         printf("No alignment file found! (%s)\n", alfil);
         exit(0);
      } else {
al_sta:  printf("Found data in %s\n", alfil);
         for (i=0; i<220; i++) {
            n = -1;
            m = -1;
            fgets(mhline, 300, mhfil);
            if (feof(mhfil)) goto q_end;
            sscanf(mhline, "%d", &n);
         if (n == 1) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* coll_pitch = indat[n][jemx] */
         if (n == 2) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* coll_h = indat[n][jemx] */
         if (n == 3) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* coll_w = indat[n][jemx] */
         if (n == 4) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* coll_r = indat[n][jemx] */
         if (n == 5) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* mask_r = indat[n][jemx] */
         if (n == 6) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* mask_height = indat[n][jemx] */
         if (n == 7) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* hexa_dim = indat[n][jemx] */
         if (n == 8) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* struc_h2 = indat[n][jemx] */
         if (n == 9) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* struc_h1 = indat[n][jemx] */
         if (n == 10) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* alfa = indat[n][jemx] */
         if (n == 11) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* beta = indat[n][jemx] */
         if (n == 12) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* gamma = indat[n][jemx] */
         if (n == 13) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* xshi = indat[n][jemx] */
         if (n == 14) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* yshi = indat[n][jemx] */
         if (n == 15) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* c_tiltx = indat[n][jemx] */
         if (n == 16) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* c_tilty = indat[n][jemx] */
         if (n == 17) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* coll_wb = indat[n][jemx] */
         if (n == 20) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* indep = indat[n][jemx] */
         if (n == 21) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* FOV_radius = indat[n][jemx] */
         if (n == 22) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* coll_curv = indat[n][jemx] */
         if (n == 23) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* mask_scale = indat[n][jemx] */
         
         if (n == 30) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* x_rms[0] = indat[n][jemx] */
         if (n == 31) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* x_rms[1] = indat[n][jemx] */
         if (n == 32) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* x_rms[2] = indat[n][jemx] */
         if (n == 33) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* x_rms[3] = indat[n][jemx] */
         if (n == 34) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* x_rms[4] = indat[n][jemx] */
         if (n == 35) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* rmsfact = indat[n][jemx] */
         if (n == 40) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* y_rms[0] = indat[n][jemx] */
         if (n == 41) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* y_rms[1] = indat[n][jemx] */
         if (n == 42) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* y_rms[2] = indat[n][jemx] */
         if (n == 43) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* y_rms[3] = indat[n][jemx] */
         if (n == 44) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* y_rms[4] = indat[n][jemx] */
         if (n == 100) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* scaleX = indat[n][jemx] */
         if (n == 101) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* scaleY = indat[n][jemx] */
         if (n == 102) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* phase2 = indat[n][jemx] */
         if (n == 103) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* x2x = indat[n][jemx] */
         if (n == 104) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* y2y = indat[n][jemx] */
         if (n == 105) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* offX = indat[n][jemx] */
         if (n == 106) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* offY = indat[n][jemx] */
         if (n == 107) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* offQ = indat[n][jemx] */
         if (n == 108) sscanf(mhline, "%d %lf %lf", &m, &indat[n][0], &indat[n][1]); /* offR = indat[n][jemx] */
            printf("reading line %3d, found n: %3d", i, n);
            if (m > 0) {
               printf("  parameter values: %8.3lf  %8.3lf \n", indat[n][0], indat[n][1]);
               indat[n][2] = 0.0;
            }
            else printf("\n");
         }
      }
q_end:
      fclose(mhfil);

      sprintf(oname, "go_scan_par_%02d", par_num);
      out2 = fopen(oname, "wt");
      if (out2 == NULL) {
         printf("Could not open %s, exiting!\n", oname);
         return;
      }
      fprintf(out2, "#!/bin/tcsh -f\n");
      
      k = 0;
      for (par_val = par_low; par_val <= par_high; par_val += par_step) {
         sprintf(oname, "alignment%03d_%02d.dat", par_num, k);
         out = fopen(oname, "wt");
         if (out == NULL) {
            printf("Could not open %s, exiting!\n", oname);
            return;
         }
         for (i=0; i<110; i++) { 
            if (indat[i][2] == 0.0) { 
               if (i == par_num) fprintf(out, "%4d   %9.5f  %9.5f\n", par_num, par_val, par_val);
               else fprintf(out, "%4d   %9.5f  %9.5f\n", i, indat[i][0], indat[i][1]);
            }
         }
         fclose(out);
      
         fprintf(out2, "cp alignment%03d_%02d.dat alignment.dat\n", par_num, k);
         fprintf(out2, "./go_2_f2lc %1d %03d %9.5f %02d\n", jemx, par_num, par_val, k);

         k++;
      }
      fclose(out2);
}
